Index: cpp/tests/geometry_goals/cuboid-linux.goal
===================================================================
--- cpp/tests/geometry_goals/cuboid-linux.goal	(revision 1015)
+++ cpp/tests/geometry_goals/cuboid-linux.goal	(revision 1015)
@@ -0,0 +1,46 @@
+[WARN] Param.set: Setting 'scale.x' in 'Part': p.sx = '100.0' exceeded allowed range (too big). Adjusted to '5.0'.
+[WARN] Model.internalCheck: scale.x too big in Part #12 (adjusted)
+[WARN] Model.internalCheck: scale.y too big in Part #13 (adjusted)
+//0s
+p:sh=1, sx=0.1, sy=0.1, sz=0.1, vg=0.0
+p:sh=2, sx=0.5, sy=0.05, sz=0.05, vg=0.0, 0.0
+p:sh=2, sx=0.05, sy=0.5, sz=0.05, vr=0.0, vb=0.0
+p:sh=2, sx=0.05, sy=0.05, sz=0.5, vr=0.0, 0.0
+p:-5.0, -1.0, -1.0, sh=1, sx=0.05, sy=0.05, sz=0.05, vb=0.0
+p:-5.0, -1.0, 1.0, sh=1, sx=0.05, sy=0.05, sz=0.05, vb=0.0
+p:-5.0, 1.0, -1.0, sh=1, sx=0.05, sy=0.05, sz=0.05, vb=0.0
+p:-5.0, 1.0, 1.0, sh=1, sx=0.05, sy=0.05, sz=0.05, vb=0.0
+p:5.0, -1.0, -1.0, sh=1, sx=0.05, sy=0.05, sz=0.05, vb=0.0
+p:5.0, -1.0, 1.0, sh=1, sx=0.05, sy=0.05, sz=0.05, vb=0.0
+p:5.0, 1.0, -1.0, sh=1, sx=0.05, sy=0.05, sz=0.05, vb=0.0
+p:5.0, 1.0, 1.0, sh=1, sx=0.05, sy=0.05, sz=0.05, vb=0.0
+p:sh=2, sx=5.0, sy=0.05, sz=0.05, rx=-2.375430003896009, 0.1936583004443267, 0.19739555984988078, vg=0.0, 0.0
+p:sh=2, sx=0.05, sy=5.0, sz=0.05, rx=-2.375430003896009, 0.1936583004443267, 0.19739555984988078, vr=0.0, vb=0.0
+p:sh=2, sx=0.05, sy=0.05, sz=2.828427124746191, rx=-2.375430003896009, 0.1936583004443267, 0.19739555984988078, vr=0.0, 0.0
+p:sh=2, sx=5.0
+j:0, 1, sh=1
+j:0, 2, sh=1
+j:0, 3, sh=1
+j:0, 4, sh=1
+j:0, 5, sh=1
+j:0, 6, sh=1
+j:0, 7, sh=1
+j:0, 8, sh=1
+j:0, 9, sh=1
+j:0, 10, sh=1
+j:0, 11, sh=1
+j:0, 12, sh=1
+j:0, 13, sh=1
+j:0, 14, sh=1
+j:0, 15, sh=1
+
+# volume=40.000000
+# area=88.000000
+# sizes.x=10.392305 sizes.y=5.443311 sizes.z=2.828427
+# axes.x=(0.962250, 0.192450, 0.192450)
+# axes.y=(0.272166, -0.680414, -0.680414)
+# axes.z=(0.000000, 0.707107, -0.707107)
+# box.x=[-5.000000, 5.000000]
+# box.y=[-1.000000, 1.000000]
+# box.z=[-1.000000, 1.000000]
+
Index: cpp/tests/geometry_goals/cylinder-linux.goal
===================================================================
--- cpp/tests/geometry_goals/cylinder-linux.goal	(revision 1015)
+++ cpp/tests/geometry_goals/cylinder-linux.goal	(revision 1015)
@@ -0,0 +1,45 @@
+[WARN] Param.set: Setting 'scale.x' in 'Part': p.sx = '100.0' exceeded allowed range (too big). Adjusted to '5.0'.
+[WARN] Model.internalCheck: scale.x too big in Part #12 (adjusted)
+//0s
+p:sh=1, sx=0.1, sy=0.1, sz=0.1, vg=0.0
+p:sh=2, sx=0.5, sy=0.05, sz=0.05, vg=0.0, 0.0
+p:sh=2, sx=0.05, sy=0.5, sz=0.05, vr=0.0, vb=0.0
+p:sh=2, sx=0.05, sy=0.05, sz=0.5, vr=0.0, 0.0
+p:-5.0, -1.0, -1.0, sh=1, sx=0.05, sy=0.05, sz=0.05, vb=0.0
+p:-5.0, -1.0, 1.0, sh=1, sx=0.05, sy=0.05, sz=0.05, vb=0.0
+p:-5.0, 1.0, -1.0, sh=1, sx=0.05, sy=0.05, sz=0.05, vb=0.0
+p:-5.0, 1.0, 1.0, sh=1, sx=0.05, sy=0.05, sz=0.05, vb=0.0
+p:5.0, -1.0, -1.0, sh=1, sx=0.05, sy=0.05, sz=0.05, vb=0.0
+p:5.0, -1.0, 1.0, sh=1, sx=0.05, sy=0.05, sz=0.05, vb=0.0
+p:5.0, 1.0, -1.0, sh=1, sx=0.05, sy=0.05, sz=0.05, vb=0.0
+p:5.0, 1.0, 1.0, sh=1, sx=0.05, sy=0.05, sz=0.05, vb=0.0
+p:sh=2, sx=5.0, sy=0.05, sz=0.05, rz=0.19739555984988075, vg=0.0, 0.0
+p:sh=2, sx=0.05, sy=3.922322702763681, sz=0.05, rz=0.19739555984988075, vr=0.0, vb=0.0
+p:sh=2, sx=0.05, sy=0.05, sz=2.0, rz=0.19739555984988075, vr=0.0, 0.0
+p:sh=3, sx=5.0
+j:0, 1, sh=1
+j:0, 2, sh=1
+j:0, 3, sh=1
+j:0, 4, sh=1
+j:0, 5, sh=1
+j:0, 6, sh=1
+j:0, 7, sh=1
+j:0, 8, sh=1
+j:0, 9, sh=1
+j:0, 10, sh=1
+j:0, 11, sh=1
+j:0, 12, sh=1
+j:0, 13, sh=1
+j:0, 14, sh=1
+j:0, 15, sh=1
+
+# volume=20.800000
+# area=69.115038
+# sizes.x=10.198039 sizes.y=3.922323 sizes.z=2.000000
+# axes.x=(0.980581, 0.196116, 0.000000)
+# axes.y=(-0.196116, 0.980581, 0.000000)
+# axes.z=(0.000000, -0.000000, 1.000000)
+# box.x=[-5.000000, 5.000000]
+# box.y=[-1.000000, 1.000000]
+# box.z=[-1.000000, 1.000000]
+
Index: cpp/tests/geometry_goals/ellipsoid-linux.goal
===================================================================
--- cpp/tests/geometry_goals/ellipsoid-linux.goal	(revision 1015)
+++ cpp/tests/geometry_goals/ellipsoid-linux.goal	(revision 1015)
@@ -0,0 +1,45 @@
+[WARN] Param.set: Setting 'scale.x' in 'Part': p.sx = '100.0' exceeded allowed range (too big). Adjusted to '5.0'.
+[WARN] Model.internalCheck: scale.x too big in Part #12 (adjusted)
+//0s
+p:sh=1, sx=0.1, sy=0.1, sz=0.1, vg=0.0
+p:sh=2, sx=0.5, sy=0.05, sz=0.05, vg=0.0, 0.0
+p:sh=2, sx=0.05, sy=0.5, sz=0.05, vr=0.0, vb=0.0
+p:sh=2, sx=0.05, sy=0.05, sz=0.5, vr=0.0, 0.0
+p:-5.0, -1.0, -1.0, sh=1, sx=0.05, sy=0.05, sz=0.05, vb=0.0
+p:-5.0, -1.0, 1.0, sh=1, sx=0.05, sy=0.05, sz=0.05, vb=0.0
+p:-5.0, 1.0, -1.0, sh=1, sx=0.05, sy=0.05, sz=0.05, vb=0.0
+p:-5.0, 1.0, 1.0, sh=1, sx=0.05, sy=0.05, sz=0.05, vb=0.0
+p:5.0, -1.0, -1.0, sh=1, sx=0.05, sy=0.05, sz=0.05, vb=0.0
+p:5.0, -1.0, 1.0, sh=1, sx=0.05, sy=0.05, sz=0.05, vb=0.0
+p:5.0, 1.0, -1.0, sh=1, sx=0.05, sy=0.05, sz=0.05, vb=0.0
+p:5.0, 1.0, 1.0, sh=1, sx=0.05, sy=0.05, sz=0.05, vb=0.0
+p:sh=2, sx=5.0, sy=0.05, sz=0.05, vg=0.0, 0.0
+p:sh=2, sx=0.05, sy=2.0, sz=0.05, vr=0.0, vb=0.0
+p:sh=2, sx=0.05, sy=0.05, sz=2.0, vr=0.0, 0.0
+p:sh=1, sx=5.0
+j:0, 1, sh=1
+j:0, 2, sh=1
+j:0, 3, sh=1
+j:0, 4, sh=1
+j:0, 5, sh=1
+j:0, 6, sh=1
+j:0, 7, sh=1
+j:0, 8, sh=1
+j:0, 9, sh=1
+j:0, 10, sh=1
+j:0, 11, sh=1
+j:0, 12, sh=1
+j:0, 13, sh=1
+j:0, 14, sh=1
+j:0, 15, sh=1
+
+# volume=11.657143
+# area=49.958862
+# sizes.x=10.000000 sizes.y=2.000000 sizes.z=2.000000
+# axes.x=(1.000000, 0.000000, 0.000000)
+# axes.y=(0.000000, 1.000000, 0.000000)
+# axes.z=(0.000000, 0.000000, 1.000000)
+# box.x=[-5.000000, 5.000000]
+# box.y=[-1.000000, 1.000000]
+# box.z=[-1.000000, 1.000000]
+