Index: cpp/frams/config/f0-SDK.def
===================================================================
--- cpp/frams/config/f0-SDK.def	(revision 1038)
+++ cpp/frams/config/f0-SDK.def	(revision 1039)
@@ -28,5 +28,4 @@
 PROP(i,1,0,`info',s,,,,info)
 PROP(Vstyle,2,0,vis_style,s,0,0,part,vis_style)
-XPROP(vs,2,0,visual thickness,f,0.05,0.7,0.2,vsize)
 XPROP(vr,2,0,red component,f,0.0,1.0,1.0,vcolor.x)
 XPROP(vg,2,1024,green component,f,0.0,1.0,1.0,vcolor.y)
Index: cpp/frams/config/f0.def
===================================================================
--- cpp/frams/config/f0.def	(revision 1038)
+++ cpp/frams/config/f0.def	(revision 1039)
@@ -28,5 +28,4 @@
 PROP(i,1,0,`info',s,,,,info)
 PROP(Vstyle,2,0,vis_style,s,0,0,part,vis_style)
-XPROP(vs,2,0,visual thickness,f,0.05,0.7,0.2,vsize)
 XPROP(vr,2,0,red component,f,0.0,1.0,1.0,vcolor.x)
 XPROP(vg,2,1024,green component,f,0.0,1.0,1.0,vcolor.y)
Index: cpp/frams/genetics/f1/f1_conv.cpp
===================================================================
--- cpp/frams/genetics/f1/f1_conv.cpp	(revision 1038)
+++ cpp/frams/genetics/f1/f1_conv.cpp	(revision 1039)
@@ -282,6 +282,6 @@
 int Builder::growPart(GeneProps &c, const char *g)
 {
-	sprintf(tmp, "dn=%lg,fr=%lg,ing=%lg,as=%lg,vs=%g,vr=%g,vg=%g,vb=%g",
-		1.0 / c.weight, c.friction, c.ingestion, c.assimilation, c.visual_size, c.cred, c.cgreen, c.cblue);
+	sprintf(tmp, "dn=%lg,fr=%lg,ing=%lg,as=%lg,vr=%g,vg=%g,vb=%g",
+		1.0 / c.weight, c.friction, c.ingestion, c.assimilation, c.cred, c.cgreen, c.cblue);
 	return model.addFromString(Model::PartType, tmp, makeRange(g));
 }
Index: cpp/frams/genetics/f9/f9_conv.cpp
===================================================================
--- cpp/frams/genetics/f9/f9_conv.cpp	(revision 1038)
+++ cpp/frams/genetics/f9/f9_conv.cpp	(revision 1039)
@@ -153,6 +153,4 @@
 			averagecolor += j->vcolor;
 		p->vcolor = averagecolor / count;
-		if (count > 5) count = 5; //avoid too fat...
-		p->vsize = 0.3 + count / 15.0; //the more Joints is attached to a Part, the fatter it is
 	}
 	//m.getPart(0)->vcolor = Pt3D(0, 0, 0); //mark first Part black - a visual aid for easier editing
Index: cpp/frams/genetics/geneprops.cpp
===================================================================
--- cpp/frams/genetics/geneprops.cpp	(revision 1038)
+++ cpp/frams/genetics/geneprops.cpp	(revision 1039)
@@ -24,5 +24,4 @@
 	muscle_reset_range = true;
 
-	visual_size = 0.2;
 	cred = 0.5;
 	cgreen = 0.5;
@@ -89,6 +88,4 @@
 	case 'B': cblue += (1.0 - cblue)*0.25;  break;
 	case 'b': cblue += (0.0 - cblue)*0.25;  break;
-	case 'H': visual_size += (0.7 - visual_size)*0.25;  break;
-	case 'h': visual_size += (0.05 - visual_size)*0.25;  break;
 
 	default: return -1;
@@ -112,6 +109,4 @@
 	normalizeBiol4();
 
-	visual_size = 0.5*visual_size + 0.5 * standard_values.visual_size;
-
 	if (use_f1_muscle_reset_range)
 	{
Index: cpp/frams/genetics/geneprops.h
===================================================================
--- cpp/frams/genetics/geneprops.h	(revision 1038)
+++ cpp/frams/genetics/geneprops.h	(revision 1039)
@@ -13,5 +13,5 @@
 
 
-#define F14_MODIFIERS_VISUAL "DdGgBbHh"
+#define F14_MODIFIERS_VISUAL "DdGgBb"
 #define F14_MODIFIERS_RARE "EeWwAaSs" //expdef would need to handle these properly/specifically to ensure reasonable behavior, and hardly any expdef does. Modifying initial energy of a creature as a result of its genes (Ee) is in general not a good idea. Weight (Ww) works only in water, and in water sinking/going up should usually be caused by real "intentional" activity of a creature, not by its inherited weight. For assimilation (Aa), there is a dedicated parameter in CreaturesGroup. Stamina (Ss) is no longer needed as destructive collisions are not supported, and even if they were, some expdef would need to impose reasonable restrictions on the value of this parameter (e.g. similar to normalizeBiol4()) so there is some cost associated with it, and the specific consequences of destructions should be defined as needed.
 #define F14_MODIFIERS "LlRrCcQqFfMmIi" F14_MODIFIERS_RARE F14_MODIFIERS_VISUAL
@@ -50,5 +50,4 @@
 	bool muscle_reset_range;  ///<Used only by conv_f1
 
-	double visual_size;       ///<incremented by H, decremented by h. Part's visual size, only affects appearance
 	double cred;              ///<incremented by D, decremented by d. Part's red color proportion
 	double cgreen;            ///<incremented by B, decremented by b. Part's blue color proportion
Index: cpp/frams/model/defassign-f0-SDK.h
===================================================================
--- cpp/frams/model/defassign-f0-SDK.h	(revision 1038)
+++ cpp/frams/model/defassign-f0-SDK.h	(revision 1039)
@@ -20,5 +20,4 @@
 assim=0.25;
 vis_style="part";
-vsize=0.2;
 vcolor.x=1.0;
 vcolor.y=1.0;
Index: cpp/frams/model/f0-SDK-classes.h
===================================================================
--- cpp/frams/model/f0-SDK-classes.h	(revision 1038)
+++ cpp/frams/model/f0-SDK-classes.h	(revision 1039)
@@ -24,5 +24,5 @@
 ParamEntry f0_part_paramtab[]=
 {
- {"Geometry",3,22,"p",NULL,0,NULL,NULL,"Part"},
+ {"Geometry",3,21,"p",NULL,0,NULL,NULL,"Part"},
  {"Other properties",},
  {"Visual",},
@@ -45,5 +45,4 @@
  {"i",1,0,"info","s",FIELD(info),},
  {"Vstyle",2,0,"vis_style","s 0 0 part",FIELD(vis_style),},
- {"vs",2,0,"visual thickness","f 0.05 0.7 0.2",FIELD(vsize),},
  {"vr",2,0,"red component","f 0.0 1.0 1.0",FIELD(vcolor.x),},
  {"vg",2,1024,"green component","f 0.0 1.0 1.0",FIELD(vcolor.y),},
@@ -53,5 +52,5 @@
 ParamEntry f0_part_xtra_paramtab[]=
 {
- {"Extra properties",1,9,"p"},
+ {"Extra properties",1,8,"p"},
  {"h",0,0,"hollow","f 0 1 0",FIELD(hollow),},
  {"dn",0,0,"density","f 0.2 5.0 1.0",FIELD(density),},
@@ -59,5 +58,4 @@
  {"ing",0,0,"ingestion","f 0.0 1.0 0.25",FIELD(ingest),},
  {"as",0,0,"assimilation","f 0.0 1.0 0.25",FIELD(assim),},
- {"vs",0,0,"visual thickness","f 0.05 0.7 0.2",FIELD(vsize),},
  {"vr",0,0,"red component","f 0.0 1.0 1.0",FIELD(vcolor.x),},
  {"vg",0,1024,"green component","f 0.0 1.0 1.0",FIELD(vcolor.y),},
Index: cpp/frams/model/model.cpp
===================================================================
--- cpp/frams/model/model.cpp	(revision 1038)
+++ cpp/frams/model/model.cpp	(revision 1039)
@@ -920,5 +920,4 @@
 			VALIDMINMAX(p, Part, ingest);
 			VALIDMINMAX(p, Part, assim);
-			VALIDMINMAX(p, Part, vsize);
 			VALIDMINMAX(p, Part, vcolor.x);
 			VALIDMINMAX(p, Part, vcolor.y);
Index: cpp/frams/model/modelparts.cpp
===================================================================
--- cpp/frams/model/modelparts.cpp	(revision 1038)
+++ cpp/frams/model/modelparts.cpp	(revision 1039)
@@ -591,5 +591,4 @@
 	refno = src.refno;
 	vcolor = src.vcolor;
-	vsize = src.vsize;
 	vis_style = src.vis_style;
 	shape = src.shape;
Index: cpp/frams/model/modelparts.h
===================================================================
--- cpp/frams/model/modelparts.h	(revision 1038)
+++ cpp/frams/model/modelparts.h	(revision 1039)
@@ -111,5 +111,4 @@
 
 	Pt3D vcolor;
-	double vsize;
 
 	Part(enum Shape s = SHAPE_BALL);