Index: java/Framclipse/com.framsticks.framclipse/res/framscript.xml
===================================================================
--- java/Framclipse/com.framsticks.framclipse/res/framscript.xml	(revision 1042)
+++ java/Framclipse/com.framsticks.framclipse/res/framscript.xml	(revision 1058)
@@ -1722,4 +1722,7 @@
 			<description><![CDATA[]]></description>
 		</element>
+		<element name="f0s_p_rot" type="float" min="0" max="100" default="10.0">
+			<description><![CDATA[]]></description>
+		</element>
 		<element name="f0s_p_scale" type="float" min="0" max="100" default="10.0">
 			<description><![CDATA[]]></description>
@@ -1733,7 +1736,4 @@
 		<element name="f0s_p_asm" type="float" min="0" max="100" default="0.0">
 			<description><![CDATA[The interpretation and influence of this property must be implemented by the experiment definition]]></description>
-		</element>
-		<element name="f0s_p_vsiz" type="float" min="0" max="100" default="0.0">
-			<description><![CDATA[]]></description>
 		</element>
 		<element name="f0s_j_new" type="float" min="0" max="100" default="5.0">
@@ -2802,39 +2802,4 @@
 <arguments/></element>
 	</type>
-	<type name="ModelSimilarity" context="Global context">
-<description><![CDATA[Evaluates morphological dissimilarity. More information:
-http://www.framsticks.com/bib/Komosinski-et-al-2001
-http://www.framsticks.com/bib/Komosinski-and-Kubiak-2011
-http://www.framsticks.com/bib/Komosinski-2016
-https://doi.org/10.1007/978-3-030-16692-2_8]]></description>
-		<element name="simil_method" type="integer" min="0" max="1" default="0">
-			<description><![CDATA[]]></description>
-		</element>
-		<element name="simil_parts" type="float" min="0" max="100" default="0.0">
-			<description><![CDATA[Differing number of parts is also handled by the 'part degree' similarity component.]]></description>
-		</element>
-		<element name="simil_partdeg" type="float" min="0" max="100" default="1.0">
-			<description><![CDATA[]]></description>
-		</element>
-		<element name="simil_neuro" type="float" min="0" max="100" default="0.1">
-			<description><![CDATA[]]></description>
-		</element>
-		<element name="simil_partgeom" type="float" min="0" max="100" default="0.0">
-			<description><![CDATA[]]></description>
-		</element>
-		<element name="simil_fixedZaxis" type="integer" min="0" max="1" default="0">
-			<description><![CDATA[]]></description>
-		</element>
-		<element name="simil_weightedMDS" type="integer" min="0" max="1" default="0">
-			<description><![CDATA[If activated, weighted MDS with vertex (i.e., Part) degrees as weights is used for 3D alignment of body structure.]]></description>
-		</element>
-		<element name="evaluateDistance" function="true" type="float" flags="34">
-			<description><![CDATA[Calculates dissimilarity between two models created from Geno objects.]]></description>
-			<arguments>
-				<argument type="Geno"/>
-				<argument type="Geno"/>
-			</arguments>
-		</element>
-	</type>
 	<type name="ModelSymmetry" context="Global context">
 <description><![CDATA[Calculates bilateral symmetry. Details are described in http://www.framsticks.com/bib/Jaskowski-and-Komosinski-2008]]></description>
@@ -4941,4 +4906,7 @@
 			<description><![CDATA[]]></description>
 		</element>
+		<element name="f0s_p_rot" type="float" min="0" max="100" default="10.0">
+			<description><![CDATA[]]></description>
+		</element>
 		<element name="f0s_p_scale" type="float" min="0" max="100" default="10.0">
 			<description><![CDATA[]]></description>
@@ -4952,7 +4920,4 @@
 		<element name="f0s_p_asm" type="float" min="0" max="100" default="0.0">
 			<description><![CDATA[The interpretation and influence of this property must be implemented by the experiment definition]]></description>
-		</element>
-		<element name="f0s_p_vsiz" type="float" min="0" max="100" default="0.0">
-			<description><![CDATA[]]></description>
 		</element>
 		<element name="f0s_j_new" type="float" min="0" max="100" default="5.0">
@@ -5656,6 +5621,31 @@
    time (t) float 0..6.28319 (default 0)]]></description>
 		</element>
-		<element name="simil_method" type="integer" min="0" max="1" default="0">
-			<description><![CDATA[]]></description>
+		<element name="type" type="integer" min="0" max="2" default="1">
+			<description><![CDATA[]]></description>
+		</element>
+		<element name="evaluateDistance" function="true" type="float" flags="34">
+			<description><![CDATA[Calculates dissimilarity between two models created from Geno objects.]]></description>
+			<arguments>
+				<argument type="Geno"/>
+				<argument type="Geno"/>
+			</arguments>
+		</element>
+		<element name="simil_greedy_parts" type="float" min="0" max="100" default="0.0">
+			<description><![CDATA[Differing number of parts is also handled by the 'part degree' similarity component.]]></description>
+		</element>
+		<element name="simil_greedy_partdeg" type="float" min="0" max="100" default="1.0">
+			<description><![CDATA[]]></description>
+		</element>
+		<element name="simil_greedy_neuro" type="float" min="0" max="100" default="0.1">
+			<description><![CDATA[]]></description>
+		</element>
+		<element name="simil_greedy_partgeom" type="float" min="0" max="100" default="0.0">
+			<description><![CDATA[]]></description>
+		</element>
+		<element name="simil_greedy_fixedZaxis" type="integer" min="0" max="1" default="0">
+			<description><![CDATA[]]></description>
+		</element>
+		<element name="simil_greedy_weightedMDS" type="integer" min="0" max="1" default="0">
+			<description><![CDATA[If activated, weighted MDS with vertex (i.e., Part) degrees as weights is used for 3D alignment of body structure.]]></description>
 		</element>
 		<element name="simil_parts" type="float" min="0" max="100" default="0.0">
@@ -5677,10 +5667,12 @@
 			<description><![CDATA[If activated, weighted MDS with vertex (i.e., Part) degrees as weights is used for 3D alignment of body structure.]]></description>
 		</element>
-		<element name="evaluateDistance" function="true" type="float" flags="34">
-			<description><![CDATA[Calculates dissimilarity between two models created from Geno objects.]]></description>
-			<arguments>
-				<argument type="Geno"/>
-				<argument type="Geno"/>
-			</arguments>
+		<element name="simil_density" type="float" min="1" max="100" default="10.0">
+			<description><![CDATA[]]></description>
+		</element>
+		<element name="simil_bin_num" type="integer" min="1" max="1000" default="128">
+			<description><![CDATA[]]></description>
+		</element>
+		<element name="simil_samples_num" type="integer" min="1" max="1048576" default="1048576">
+			<description><![CDATA[]]></description>
 		</element>
 		<element name="calculateSymmetry" function="true" type="float" flags="32">
@@ -5740,4 +5732,104 @@
 		<element name="minjoint" type="float" min="0" max="100" default="0.0"/>
 		<element name="maxjoint" type="float" min="0" max="100" default="2.0"/>
+	</type>
+	<type name="SimilMeasure" context="Global context">
+<description><![CDATA[Evaluates morphological dissimilarity. More information:
+http://www.framsticks.com/bib/Komosinski-et-al-2001
+http://www.framsticks.com/bib/Komosinski-and-Kubiak-2011
+http://www.framsticks.com/bib/Komosinski-2016
+https://doi.org/10.1007/978-3-030-16692-2_8]]></description>
+		<element name="type" type="integer" min="0" max="2" default="1">
+			<description><![CDATA[]]></description>
+		</element>
+		<element name="evaluateDistance" function="true" type="float" flags="34">
+			<description><![CDATA[Calculates dissimilarity between two models created from Geno objects.]]></description>
+			<arguments>
+				<argument type="Geno"/>
+				<argument type="Geno"/>
+			</arguments>
+		</element>
+	</type>
+	<type name="SimilMeasureDistribution" context="Global context">
+<description><![CDATA[Evaluates morphological dissimilarity using distribution measure.]]></description>
+		<element name="simil_density" type="float" min="1" max="100" default="10.0">
+			<description><![CDATA[]]></description>
+		</element>
+		<element name="simil_bin_num" type="integer" min="1" max="1000" default="128">
+			<description><![CDATA[]]></description>
+		</element>
+		<element name="simil_samples_num" type="integer" min="1" max="1048576" default="1048576">
+			<description><![CDATA[]]></description>
+		</element>
+		<element name="evaluateDistance" function="true" type="float" flags="34">
+			<description><![CDATA[Calculates dissimilarity between two models created from Geno objects.]]></description>
+			<arguments>
+				<argument type="Geno"/>
+				<argument type="Geno"/>
+			</arguments>
+		</element>
+	</type>
+	<type name="SimilMeasureGreedy" context="Global context">
+<description><![CDATA[Evaluates morphological dissimilarity using greedy measure. More information:
+http://www.framsticks.com/bib/Komosinski-et-al-2001
+http://www.framsticks.com/bib/Komosinski-and-Kubiak-2011
+http://www.framsticks.com/bib/Komosinski-2016
+https://doi.org/10.1007/978-3-030-16692-2_8]]></description>
+		<element name="simil_greedy_parts" type="float" min="0" max="100" default="0.0">
+			<description><![CDATA[Differing number of parts is also handled by the 'part degree' similarity component.]]></description>
+		</element>
+		<element name="simil_greedy_partdeg" type="float" min="0" max="100" default="1.0">
+			<description><![CDATA[]]></description>
+		</element>
+		<element name="simil_greedy_neuro" type="float" min="0" max="100" default="0.1">
+			<description><![CDATA[]]></description>
+		</element>
+		<element name="simil_greedy_partgeom" type="float" min="0" max="100" default="0.0">
+			<description><![CDATA[]]></description>
+		</element>
+		<element name="simil_greedy_fixedZaxis" type="integer" min="0" max="1" default="0">
+			<description><![CDATA[]]></description>
+		</element>
+		<element name="simil_greedy_weightedMDS" type="integer" min="0" max="1" default="0">
+			<description><![CDATA[If activated, weighted MDS with vertex (i.e., Part) degrees as weights is used for 3D alignment of body structure.]]></description>
+		</element>
+		<element name="evaluateDistance" function="true" type="float" flags="34">
+			<description><![CDATA[Calculates dissimilarity between two models created from Geno objects.]]></description>
+			<arguments>
+				<argument type="Geno"/>
+				<argument type="Geno"/>
+			</arguments>
+		</element>
+	</type>
+	<type name="SimilMeasureHungarian" context="Global context">
+<description><![CDATA[Evaluates morphological dissimilarity using hungarian measure. More information:
+http://www.framsticks.com/bib/Komosinski-et-al-2001
+http://www.framsticks.com/bib/Komosinski-and-Kubiak-2011
+http://www.framsticks.com/bib/Komosinski-2016
+https://doi.org/10.1007/978-3-030-16692-2_8]]></description>
+		<element name="simil_parts" type="float" min="0" max="100" default="0.0">
+			<description><![CDATA[Differing number of parts is also handled by the 'part degree' similarity component.]]></description>
+		</element>
+		<element name="simil_partdeg" type="float" min="0" max="100" default="1.0">
+			<description><![CDATA[]]></description>
+		</element>
+		<element name="simil_neuro" type="float" min="0" max="100" default="0.1">
+			<description><![CDATA[]]></description>
+		</element>
+		<element name="simil_partgeom" type="float" min="0" max="100" default="0.0">
+			<description><![CDATA[]]></description>
+		</element>
+		<element name="simil_fixedZaxis" type="integer" min="0" max="1" default="0">
+			<description><![CDATA[]]></description>
+		</element>
+		<element name="simil_weightedMDS" type="integer" min="0" max="1" default="0">
+			<description><![CDATA[If activated, weighted MDS with vertex (i.e., Part) degrees as weights is used for 3D alignment of body structure.]]></description>
+		</element>
+		<element name="evaluateDistance" function="true" type="float" flags="34">
+			<description><![CDATA[Calculates dissimilarity between two models created from Geno objects.]]></description>
+			<arguments>
+				<argument type="Geno"/>
+				<argument type="Geno"/>
+			</arguments>
+		</element>
 	</type>
 	<type name="Simulator" context="Global context">