Index: java/Framclipse/com.framsticks.framclipse/res/framscript.xml
===================================================================
--- java/Framclipse/com.framsticks.framclipse/res/framscript.xml	(revision 1058)
+++ java/Framclipse/com.framsticks.framclipse/res/framscript.xml	(revision 1086)
@@ -945,11 +945,11 @@
 		</element>
 		<element name="worst" function="true" type="Genotype" flags="34">
-			<description><![CDATA[Returns the genotype object having the lowest fitness. Unrated genotypes (instances==0) are ranked lower than those having at least one instance.]]></description>
+			<description><![CDATA[Returns the genotype object having the lowest fitness. Unrated genotypes (with instances=0) are ranked lower than those having at least one instance.]]></description>
 <arguments/></element>
 		<element name="best" function="true" type="Genotype" flags="34">
-			<description><![CDATA[Returns the genotype object having the highest fitness. Unrated genotypes (instances==0) are ranked lower than those having at least one instance.]]></description>
+			<description><![CDATA[Returns the genotype object having the highest fitness. Unrated genotypes (with instances=0) are ranked lower than those having at least one instance.]]></description>
 <arguments/></element>
 		<element name="random" function="true" type="Genotype" flags="34">
-			<description><![CDATA[Returns a random genotype object]]></description>
+			<description><![CDATA[Returns a random genotype object disregarding fitness value, but taking into account 'instances'. Unrated genotypes (with instances=0) are treated as if they had instances=1.]]></description>
 <arguments/></element>
 		<element name="roulette" function="true" type="Genotype" flags="34">
@@ -1096,5 +1096,5 @@
 		</element>
 		<element name="worst" function="true" type="integer" deprecated="true" flags="8226">
-			<description><![CDATA[Gets the worst (lowest fitness) genotype index. Unrated genotypes (instances==0) are ranked lower than those having at least one instance.]]></description>
+			<description><![CDATA[Gets the worst (lowest fitness) genotype index. Unrated genotypes (instances=0) are ranked lower than those having at least one instance.]]></description>
 <arguments/></element>
 		<element name="random" function="true" type="integer" deprecated="true" flags="8226">
@@ -1368,5 +1368,5 @@
 		</element>
 		<element name="neuadd_T" type="integer" min="0" max="1">
-			<description><![CDATA[Touch and proximity sensor (Tc+Tp combined)
+			<description><![CDATA[Touch and proximity sensor (Tcontact and Tproximity combined)
 -1=no contact
 0=just touching
@@ -2707,4 +2707,16 @@
 		</element>
 	</type>
+	<type name="MessageCatcher" context="Global context">
+<description><![CDATA[Capture error messages.]]></description>
+		<element name="new" function="true" type="MessageCatcher"><arguments/></element>
+		<element name="close" function="true" type="void" flags="256"><arguments/></element>
+		<element name="store" type="integer" min="0" max="2" default="0" flags="256"/>
+		<element name="error_count" type="integer" flags="257"/>
+		<element name="warning_count" type="integer" flags="257"/>
+		<element name="info_count" type="integer" flags="257"/>
+		<element name="stored_count" type="integer" flags="257"/>
+		<element name="messages" type="string" flags="257"/>
+		<element name="summary" type="string" flags="257"/>
+	</type>
 	<type name="Model" context="Global context">
 		<element name="se" type="float" flags="256"/>
@@ -3115,5 +3127,5 @@
 		</element>
 		<element name="ncl_T" type="integer" min="0" max="1">
-			<description><![CDATA[Touch and proximity sensor (Tc+Tp combined)
+			<description><![CDATA[Touch and proximity sensor (Tcontact and Tproximity combined)
 -1=no contact
 0=just touching
@@ -4552,5 +4564,5 @@
 		</element>
 		<element name="neuadd_T" type="integer" min="0" max="1">
-			<description><![CDATA[Touch and proximity sensor (Tc+Tp combined)
+			<description><![CDATA[Touch and proximity sensor (Tcontact and Tproximity combined)
 -1=no contact
 0=just touching
@@ -5377,5 +5389,5 @@
 		</element>
 		<element name="ncl_T" type="integer" min="0" max="1">
-			<description><![CDATA[Touch and proximity sensor (Tc+Tp combined)
+			<description><![CDATA[Touch and proximity sensor (Tcontact and Tproximity combined)
 -1=no contact
 0=just touching
@@ -6602,6 +6614,6 @@
 			</arguments>
 		</element>
-		<element name="avg" type="float" flags="257"/>
-		<element name="stdev" type="float" flags="257">
+		<element name="avg" type="untyped" flags="257"/>
+		<element name="stdev" type="untyped" flags="257">
 			<description><![CDATA[=sqrt(sum((element[i]-avg)^2)/(size-1)) which is estimated population std.dev. from sample std.dev.]]></description>
 		</element>