Index: /cpp/common/loggers/loggers.h
===================================================================
--- /cpp/common/loggers/loggers.h	(revision 1099)
+++ /cpp/common/loggers/loggers.h	(revision 1100)
@@ -100,5 +100,5 @@
 	string getMessages() const  { return msgs; }
 	string getCountSummary() const; ///< return the standard "... error(s), ... warning(s), ... message(s)" text (or empty string if count==0)
-	void setStoreOptions(int opts) {options=options&(~(StoreFirstMessage|StoreAllMessages))|(opts&(StoreFirstMessage|StoreAllMessages));}
+	void setStoreOptions(int opts) {options=(options & (~(StoreFirstMessage|StoreAllMessages))) | (opts&(StoreFirstMessage|StoreAllMessages));}
 	
 	LoggerToMemory(int opts = 0, int minimal_level_to_store = LOG_ERROR) :LoggerBase(opts), minleveltostore(minimal_level_to_store)
Index: /cpp/frams/model/similarity/simil-measure.cpp
===================================================================
--- /cpp/frams/model/similarity/simil-measure.cpp	(revision 1099)
+++ /cpp/frams/model/similarity/simil-measure.cpp	(revision 1100)
@@ -12,5 +12,5 @@
 static ParamEntry simil_measure_paramtab[] = {
 	{ "Creature: Similarity", 1, 2, "SimilMeasure", "Evaluates morphological dissimilarity. More information:\nhttp://www.framsticks.com/bib/Komosinski-et-al-2001\nhttp://www.framsticks.com/bib/Komosinski-and-Kubiak-2011\nhttp://www.framsticks.com/bib/Komosinski-2016\nhttps://doi.org/10.1007/978-3-030-16692-2_8", },
-	{ "type", 0, 0, "Type of similarity measure", "d 0 2 1 ~Graph greedy (vertex degree order and greedy matching)~Graph optimal (flexible criteria order and optimal matching)~Descriptor distribution (EMD on a histogram of descriptor values)", FIELD(type), "", },
+	{ "simil_type", 0, 0, "Type of similarity measure", "d 0 2 1 ~Graph greedy (vertex degree order and greedy matching)~Graph optimal (flexible criteria order and optimal matching)~Descriptor distribution (EMD on a histogram of descriptor values)", FIELD(type), "", },
 	{ "evaluateDistance", 0, PARAM_DONTSAVE | PARAM_USERHIDDEN, "Evaluate model dissimilarity", "p f(oGeno,oGeno)", PROCEDURE(p_evaldistance), "Calculates dissimilarity between two models created from Geno objects.", },
 	{ 0, },
Index: /experiments/frams/foraminifera/data/scripts/foraminifera.expdef
===================================================================
--- /experiments/frams/foraminifera/data/scripts/foraminifera.expdef	(revision 1099)
+++ /experiments/frams/foraminifera/data/scripts/foraminifera.expdef	(revision 1100)
@@ -988,11 +988,4 @@
 
 property:
-id:print_output
-name:Print messages
-help:Print messages on evolution progress.
-group:Extras
-type:d 0 1 0
-
-property:
 id:visualize
 name:Show reticulopodia and nutrients
@@ -1011,15 +1004,4 @@
 type:f 0 -1 0.01
 group:
-
-property:
-id:logging
-name:Log statistics to file
-type:d 0 1 0
-group:
-
-property:
-id:logPref
-name:Log prefix
-type:s
 
 property:
@@ -1281,4 +1263,21 @@
 type:d 0 1 0
 
+property:
+id:logging
+name:Log statistics to file
+type:d 0 1 0
+group:
+
+property:
+id:logPref
+name:Log prefix
+type:s
+
+property:
+id:print_evol_progress
+name:Print evolution progress
+help:Print messages on evolution progress
+type:d 0 1 0
+
 state:
 id:nutrient
Index: /experiments/frams/foraminifera/data/scripts/foraminifera.inc
===================================================================
--- /experiments/frams/foraminifera/data/scripts/foraminifera.inc	(revision 1099)
+++ /experiments/frams/foraminifera/data/scripts/foraminifera.inc	(revision 1100)
@@ -51,5 +51,5 @@
 
 		var dict = {"Time": Simulator.stepNumber, "FromIDs": mode->parentsuids, "ID": new_id, "Inherited": inherit, "Operation": oper, "Kind" : mode->gen};
-		if (ExpProperties.print_output == 1) 
+		if (ExpProperties.print_evol_progress == 1) 
 			Simulator.print("[OFFSPRING] " + String.serialize(dict));
 	}
@@ -285,5 +285,5 @@
 function print_repro_info(cr)
 {
-	if (ExpProperties.print_output == 1)
+	if (ExpProperties.print_evol_progress == 1)
 		Simulator.print("Reproduced " + cr.data->lifeparams->gen + " of species " + cr.data->lifeparams->species + " energy: " + cr.energy);
 }
Index: /framspy/frams.py
===================================================================
--- /framspy/frams.py	(revision 1099)
+++ /framspy/frams.py	(revision 1100)
@@ -302,5 +302,5 @@
 		print("*** Could not find or open '%s' from '%s'.\n*** Did you provide proper arguments and is this file readable?\n" % (lib_name, os.getcwd()))
 		raise
-	os.chdir(original_dir) # restore cwd after loading so framsticks see the expected directory
+	os.chdir(original_dir) # restore current working dir after loading the library so framsticks sees the expected directory
 
 	c_api.init.argtypes = [ctypes.c_int, ctypes.POINTER(ctypes.c_char_p)]
@@ -345,5 +345,5 @@
 	c_args = (ctypes.c_char_p * len(initargs))(*list(a.encode(ExtValue._encoding) for a in initargs))
 	c_api.init(len(initargs), c_args)
-	os.chdir(original_dir) # restore again, because framsticks change dir to 'data'
+	os.chdir(original_dir) # restore current working dir again, because framsticks changes dir to 'data'
 	Root = ExtValue._rootObject()
 	for n in dir(Root):