Index: java/Framclipse/com.framsticks.framclipse/res/framscript.xml
===================================================================
--- java/Framclipse/com.framsticks.framclipse/res/framscript.xml	(revision 1086)
+++ java/Framclipse/com.framsticks.framclipse/res/framscript.xml	(revision 1110)
@@ -1439,5 +1439,5 @@
 
 Properties:
-   power (p) float 0.01..1 (default 0.25)
+   power (p) float 0..1 (default 0.25)
    bending range (r) float 0..1 (default 1)]]></description>
 		</element>
@@ -1450,5 +1450,5 @@
 
 Properties:
-   power (p) float 0.01..1 (default 1)]]></description>
+   power (p) float 0..1 (default 1)]]></description>
 		</element>
 		<element name="neuadd_M" type="integer" min="0" max="1">
@@ -1460,5 +1460,5 @@
 
 Properties:
-   power (p) float 0.01..1 (default 1)
+   power (p) float 0..1 (default 1)
    axis (a) integer 0..1 (default 0)]]></description>
 		</element>
@@ -3198,5 +3198,5 @@
 
 Properties:
-   power (p) float 0.01..1 (default 0.25)
+   power (p) float 0..1 (default 0.25)
    bending range (r) float 0..1 (default 1)]]></description>
 		</element>
@@ -3209,5 +3209,5 @@
 
 Properties:
-   power (p) float 0.01..1 (default 1)]]></description>
+   power (p) float 0..1 (default 1)]]></description>
 		</element>
 		<element name="ncl_M" type="integer" min="0" max="1">
@@ -3219,5 +3219,5 @@
 
 Properties:
-   power (p) float 0.01..1 (default 1)
+   power (p) float 0..1 (default 1)
    axis (a) integer 0..1 (default 0)]]></description>
 		</element>
@@ -4091,5 +4091,5 @@
 	256 - creatures
 
-The standard behavior (without the second argument) is to import genotypes, parameters, and genepool and population settings (2+4+8+16). Note that "64" is not included by default, because the expdef change resets all simulator parameters, which contradicts the usual meaning of "import" in Framsticks ("add data", as opposed to "load" meaning "replace data"). Moreover, using the "64" option in scripts can be dengerous, especially all expdef and show scripts should always declare the proper expdef name in their header rather than change the expdef directly. Without the "64" option, it is always safe to "import" any file in a script regardless of the current simulator state.]]></description>
+The standard behavior (without the second argument) is to import genotypes, parameters, and genepool and population settings (2+4+8+16). Note that "64" is not included by default, because the expdef change resets all simulator parameters, which contradicts the usual meaning of "import" in Framsticks ("add data", as opposed to "load" meaning "replace data"). Moreover, using the "64" option in scripts can be dangerous, especially all expdef and show scripts should always declare the proper expdef name in their header rather than change the expdef directly. Without the "64" option, it is always safe to "import" any file in a script regardless of the current simulator state.]]></description>
 			<arguments>
 				<argument name="filename" type="string"/>
@@ -4635,5 +4635,5 @@
 
 Properties:
-   power (p) float 0.01..1 (default 0.25)
+   power (p) float 0..1 (default 0.25)
    bending range (r) float 0..1 (default 1)]]></description>
 		</element>
@@ -4646,5 +4646,5 @@
 
 Properties:
-   power (p) float 0.01..1 (default 1)]]></description>
+   power (p) float 0..1 (default 1)]]></description>
 		</element>
 		<element name="neuadd_M" type="integer" min="0" max="1">
@@ -4656,5 +4656,5 @@
 
 Properties:
-   power (p) float 0.01..1 (default 1)
+   power (p) float 0..1 (default 1)
    axis (a) integer 0..1 (default 0)]]></description>
 		</element>
@@ -5460,5 +5460,5 @@
 
 Properties:
-   power (p) float 0.01..1 (default 0.25)
+   power (p) float 0..1 (default 0.25)
    bending range (r) float 0..1 (default 1)]]></description>
 		</element>
@@ -5471,5 +5471,5 @@
 
 Properties:
-   power (p) float 0.01..1 (default 1)]]></description>
+   power (p) float 0..1 (default 1)]]></description>
 		</element>
 		<element name="ncl_M" type="integer" min="0" max="1">
@@ -5481,5 +5481,5 @@
 
 Properties:
-   power (p) float 0.01..1 (default 1)
+   power (p) float 0..1 (default 1)
    axis (a) integer 0..1 (default 0)]]></description>
 		</element>
@@ -5633,5 +5633,5 @@
    time (t) float 0..6.28319 (default 0)]]></description>
 		</element>
-		<element name="type" type="integer" min="0" max="2" default="1">
+		<element name="simil_type" type="integer" min="0" max="2" default="1">
 			<description><![CDATA[]]></description>
 		</element>
@@ -5751,5 +5751,5 @@
 http://www.framsticks.com/bib/Komosinski-2016
 https://doi.org/10.1007/978-3-030-16692-2_8]]></description>
-		<element name="type" type="integer" min="0" max="2" default="1">
+		<element name="simil_type" type="integer" min="0" max="2" default="1">
 			<description><![CDATA[]]></description>
 		</element>
@@ -5912,5 +5912,5 @@
 	256 - creatures
 
-The standard behavior (without the second argument) is to import genotypes, parameters, and genepool and population settings (2+4+8+16). Note that "64" is not included by default, because the expdef change resets all simulator parameters, which contradicts the usual meaning of "import" in Framsticks ("add data", as opposed to "load" meaning "replace data"). Moreover, using the "64" option in scripts can be dengerous, especially all expdef and show scripts should always declare the proper expdef name in their header rather than change the expdef directly. Without the "64" option, it is always safe to "import" any file in a script regardless of the current simulator state.]]></description>
+The standard behavior (without the second argument) is to import genotypes, parameters, and genepool and population settings (2+4+8+16). Note that "64" is not included by default, because the expdef change resets all simulator parameters, which contradicts the usual meaning of "import" in Framsticks ("add data", as opposed to "load" meaning "replace data"). Moreover, using the "64" option in scripts can be dangerous, especially all expdef and show scripts should always declare the proper expdef name in their header rather than change the expdef directly. Without the "64" option, it is always safe to "import" any file in a script regardless of the current simulator state.]]></description>
 			<arguments>
 				<argument name="filename" type="string"/>